From 556b4608023e71e2b7e6305a804f0e1e22f55db4 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 24 May 2025 08:33:40 +0300
Subject: [PATCH 71/71] server/*.h: Remove trailing spaces

See RM #1436

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 server/commands.h    | 22 +++++++++++-----------
 server/console.h     |  6 +++---
 server/handchat.h    |  2 +-
 server/notify.h      |  2 +-
 server/sanitycheck.h |  2 +-
 server/settings.h    |  2 +-
 server/srv_log.h     |  4 ++--
 7 files changed, 20 insertions(+), 20 deletions(-)

diff --git a/server/commands.h b/server/commands.h
index 55068bfd18..4ecc577e44 100644
--- a/server/commands.h
+++ b/server/commands.h
@@ -33,21 +33,21 @@ enum cmd_echo {
      eg accidentally removing a player in a running game.
 */
 enum command_id {
-  /* old one-letter commands: */
+  /* Old one-letter commands: */
   CMD_START_GAME = 0,
   CMD_HELP,
   CMD_LIST,
   CMD_QUIT,
   CMD_CUT,
 
-  /* completely non-harmful: */
+  /* Completely non-harmful: */
   CMD_EXPLAIN,
   CMD_SHOW,
   CMD_WALL,
   CMD_CONNECTMSG,
   CMD_VOTE,
-  
-  /* mostly non-harmful: */
+
+  /* Mostly non-harmful: */
   CMD_DEBUG,
   CMD_SET,
   CMD_TEAM,
@@ -79,9 +79,9 @@ enum command_id {
   CMD_PLAYERCOLOR,
   CMD_PLAYERNATION,
 
-  /* potentially harmful: */
+  /* Potentially harmful: */
   CMD_END_GAME,
-  CMD_SURRENDER, /* not really harmful, info level */
+  CMD_SURRENDER, /* Not really harmful, info level */
   CMD_REMOVE,
   CMD_SAVE,
   CMD_SCENSAVE,
@@ -100,14 +100,14 @@ enum command_id {
   CMD_LOCK,
   CMD_UNLOCK,
 
-  /* undocumented */
+  /* Undocumented */
   CMD_RFCSTYLE,
   CMD_SRVID,
 
-  /* pseudo-commands: */
-  CMD_NUM,              /* the number of commands - for iterations */
-  CMD_UNRECOGNIZED,     /* used as a possible iteration result */
-  CMD_AMBIGUOUS         /* used as a possible iteration result */
+  /* Pseudo-commands: */
+  CMD_NUM,              /* The number of commands - for iterations */
+  CMD_UNRECOGNIZED,     /* Used as a possible iteration result */
+  CMD_AMBIGUOUS         /* Used as a possible iteration result */
 };
 
 const struct command *command_by_number(int i);
diff --git a/server/console.h b/server/console.h
index c736b978a6..eb46cde00d 100644
--- a/server/console.h
+++ b/server/console.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 
 #define MAX_LEN_CONSOLE_LINE 1024  /* closing '\0' included */
 
-/* 
+/*
  * A note on "rfc-style":
  *
  * This style of server output, started with the /rfcstyle server
@@ -63,7 +63,7 @@ void con_write(enum rfc_status rfc_status, const char *message, ...)
 /* write to console and add line-break, and show prompt if required.
    ie, same as con_write, but without the format string stuff. */
 void con_puts(enum rfc_status rfc_status, const char *str);
-     
+
 /* ensure timely update */
 void con_flush(void);
 
diff --git a/server/handchat.h b/server/handchat.h
index 5d7b270d5e..efb3926a38 100644
--- a/server/handchat.h
+++ b/server/handchat.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/server/notify.h b/server/notify.h
index f41d1b176a..7dbde6aa69 100644
--- a/server/notify.h
+++ b/server/notify.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/server/sanitycheck.h b/server/sanitycheck.h
index 78556508fd..19a15793c1 100644
--- a/server/sanitycheck.h
+++ b/server/sanitycheck.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/server/settings.h b/server/settings.h
index 53372eaf3d..e3fc577b6d 100644
--- a/server/settings.h
+++ b/server/settings.h
@@ -26,7 +26,7 @@ extern "C" {
 #include "server_settings.h"
 
 struct sset_val_name {
-  const char *support;          /* Untranslated long support name, used 
+  const char *support;          /* Untranslated long support name, used
                                  * for saving. */
   const char *pretty;           /* Translated, used to display to the
                                  * users. */
diff --git a/server/srv_log.h b/server/srv_log.h
index 88f1a2c12d..9d8e3d6810 100644
--- a/server/srv_log.h
+++ b/server/srv_log.h
@@ -23,8 +23,8 @@
 
 struct ai_data;
 
-/* 
- * Change these and remake to watch logs from a specific 
+/*
+ * Change these and remake to watch logs from a specific
  * part of the AI code.
  */
 #define LOGLEVEL_BODYGUARD LOG_DEBUG
-- 
2.47.2