From 8e706cff8fd4c1633f6dc26a77591b8873084d96 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 7 May 2025 19:26:54 +0300
Subject: [PATCH 14/73] client/*.h: Remove trailing spaces

See RM #1374

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/audio_none.h      | 2 +-
 client/audio_sdl.h       | 2 +-
 client/chatline_common.h | 4 ++--
 client/client_main.h     | 2 +-
 client/climisc.h         | 6 +++---
 client/editor.h          | 2 +-
 client/global_worklist.h | 2 +-
 client/helpdata.h        | 6 ++++--
 client/repodlgs_common.h | 4 ++--
 client/themes_common.h   | 2 +-
 10 files changed, 17 insertions(+), 15 deletions(-)

diff --git a/client/audio_none.h b/client/audio_none.h
index 38e7670158..9854fe526b 100644
--- a/client/audio_none.h
+++ b/client/audio_none.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 2002 - R. Falke
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/client/audio_sdl.h b/client/audio_sdl.h
index 17e0e82144..a41c3ab308 100644
--- a/client/audio_sdl.h
+++ b/client/audio_sdl.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/client/chatline_common.h b/client/chatline_common.h
index 3c210fe58d..5642dd017b 100644
--- a/client/chatline_common.h
+++ b/client/chatline_common.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
@@ -49,4 +49,4 @@ void fc_destroy_ow_mutex(void);
 }
 #endif /* __cplusplus */
 
-#endif  /* FC__CHATLINE_COMMON_H */
+#endif /* FC__CHATLINE_COMMON_H */
diff --git a/client/client_main.h b/client/client_main.h
index 871e6773fa..02e698e2b2 100644
--- a/client/client_main.h
+++ b/client/client_main.h
@@ -40,7 +40,7 @@ extern "C" {
  * C_S_RUNNING:      Connected ith game in progress.
  * C_S_OVER:         Connected with game over.
  */
-enum client_states { 
+enum client_states {
   C_S_INITIAL,
   C_S_DISCONNECTED,
   C_S_PREPARING,
diff --git a/client/climisc.h b/client/climisc.h
index 1fb6e2b705..e21628ca38 100644
--- a/client/climisc.h
+++ b/client/climisc.h
@@ -54,7 +54,7 @@ struct sprite *client_government_sprite(void);
 
 void center_on_something(void);
 
-/* 
+/*
  * A compound id (cid) can hold all objects a city can build:
  * improvements (with wonders) and units. This is achieved by
  * seperation the value set: a cid < B_LAST denotes a improvement
@@ -103,9 +103,9 @@ int collect_eventually_buildable_targets(struct universal *targets,
 int collect_already_built_targets(struct universal *targets,
                                   struct city *pcity);
 
-/* the number of units in city */
+/* The number of units in city */
 int num_present_units_in_city(struct city* pcity);
-int num_supported_units_in_city(struct city* pcity);	
+int num_supported_units_in_city(struct city* pcity);
 
 void handle_event(const char *featured_text, struct tile *ptile,
                   enum event_type event, int turn, int phase, int conn_id);
diff --git a/client/editor.h b/client/editor.h
index ce83523839..a0d22b286a 100644
--- a/client/editor.h
+++ b/client/editor.h
@@ -29,7 +29,7 @@ enum editor_object_type {
   OBJTYPE_CITY,
   OBJTYPE_PLAYER,
   OBJTYPE_GAME,
-  
+
   NUM_OBJTYPES
 };
 
diff --git a/client/global_worklist.h b/client/global_worklist.h
index 2a8f79d974..a834ea9b96 100644
--- a/client/global_worklist.h
+++ b/client/global_worklist.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/client/helpdata.h b/client/helpdata.h
index 3113624116..acd04ccc1d 100644
--- a/client/helpdata.h
+++ b/client/helpdata.h
@@ -72,8 +72,10 @@ const char *helptext_extra_for_terrain_str(struct extra_type *pextra,
 #define help_items_iterate(pitem) {       \
         const struct help_item *pitem;    \
         help_iter_start();                \
-        while ((pitem = help_iter_next())) {   
-#define help_items_iterate_end }}
+        while ((pitem = help_iter_next())) {
+#define help_items_iterate_end            \
+  }                                       \
+}
 
 enum help_page_type help_type_by_requirement(const struct requirement *req);
 
diff --git a/client/repodlgs_common.h b/client/repodlgs_common.h
index 6de42e6741..cc8f8febc2 100644
--- a/client/repodlgs_common.h
+++ b/client/repodlgs_common.h
@@ -40,8 +40,8 @@ void get_economy_report_data(struct improvement_entry *entries,
 			     int *num_entries_used, int *total_cost,
 			     int *total_income);
 /* This function returns an array with the gold upkeeped units.
- * FIXME: Many clients doesn't yet use this function and show also only the
- * buildings in the economy reports 
+ * FIXME: Many clients doen't yet use this function and show also only the
+ * buildings in the economy reports.
  * I think that there should be only one function which returns an array of
  * char* arrays like some other common functions but that means updating all
  * client simultaneously and I simply can't */
diff --git a/client/themes_common.h b/client/themes_common.h
index 981ebbf606..05fd63e3d7 100644
--- a/client/themes_common.h
+++ b/client/themes_common.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 2005 The Freeciv Team
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-- 
2.47.2