From 12aa12a72c1beace552085acf5f2dc7d70008d39 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Mon, 26 May 2025 05:31:12 +0300
Subject: [PATCH 78/78] Rename aiferry.[ch] as daiferry.[ch]

See RM #1450

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 ai/classic/classicai.c               | 2 +-
 ai/default/Makefile.am               | 4 ++--
 ai/default/daidata.c                 | 2 +-
 ai/default/{aiferry.c => daiferry.c} | 2 +-
 ai/default/{aiferry.h => daiferry.h} | 6 +++---
 ai/default/daimilitary.c             | 2 +-
 ai/default/daisettler.c              | 2 +-
 ai/default/daitools.c                | 2 +-
 ai/default/daiunit.c                 | 2 +-
 ai/tex/texai.c                       | 2 +-
 meson.build                          | 2 +-
 11 files changed, 14 insertions(+), 14 deletions(-)
 rename ai/default/{aiferry.c => daiferry.c} (99%)
 rename ai/default/{aiferry.h => daiferry.h} (97%)

diff --git a/ai/classic/classicai.c b/ai/classic/classicai.c
index 46ad673f43..1cffae1bbc 100644
--- a/ai/classic/classicai.c
+++ b/ai/classic/classicai.c
@@ -24,11 +24,11 @@
 #include "advdata.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "daicity.h"
 #include "daidata.h"
 #include "daidiplomacy.h"
 #include "daidomestic.h"
+#include "daiferry.h"
 #include "daihand.h"
 #include "dailog.h"
 #include "daimilitary.h"
diff --git a/ai/default/Makefile.am b/ai/default/Makefile.am
index ceb15bbfec..b6eec6834f 100644
--- a/ai/default/Makefile.am
+++ b/ai/default/Makefile.am
@@ -15,8 +15,6 @@ AM_CPPFLAGS = \
 	-I$(top_srcdir)/gen_headers/enums
 
 libdefaultai_la_SOURCES = \
-		aiferry.c	\
-		aiferry.h	\
 		aiguard.c	\
 		aiguard.h	\
 		daiair.c	\
@@ -35,6 +33,8 @@ libdefaultai_la_SOURCES = \
 		daidomestic.h	\
 		daieffects.c	\
 		daieffects.h	\
+		daiferry.c	\
+		daiferry.h	\
 		daihand.c	\
 		daihand.h	\
 		daihunter.c	\
diff --git a/ai/default/daidata.c b/ai/default/daidata.c
index 129b608c61..4786dcf4e2 100644
--- a/ai/default/daidata.c
+++ b/ai/default/daidata.c
@@ -33,10 +33,10 @@
 #include "advdata.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "daicity.h"
 #include "daidiplomacy.h"
 #include "daieffects.h"
+#include "daiferry.h"
 #include "daiplayer.h"
 #include "daisettler.h"
 #include "daiunit.h"
diff --git a/ai/default/aiferry.c b/ai/default/daiferry.c
similarity index 99%
rename from ai/default/aiferry.c
rename to ai/default/daiferry.c
index 020a559e1c..0c3e23913a 100644
--- a/ai/default/aiferry.c
+++ b/ai/default/daiferry.c
@@ -52,7 +52,7 @@
 #include "daitools.h"
 #include "daiunit.h"
 
-#include "aiferry.h"
+#include "daiferry.h"
 
  
 /* =================== constants with special meaning =================== */
diff --git a/ai/default/aiferry.h b/ai/default/daiferry.h
similarity index 97%
rename from ai/default/aiferry.h
rename to ai/default/daiferry.h
index f8cc79f6b5..35f3d0925c 100644
--- a/ai/default/aiferry.h
+++ b/ai/default/daiferry.h
@@ -10,8 +10,8 @@
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 ***********************************************************************/
-#ifndef FC__AIFERRY_H
-#define FC__AIFERRY_H
+#ifndef FC__DAIFERRY_H
+#define FC__DAIFERRY_H
 
 #include "support.h"            /* bool type */
 
@@ -85,4 +85,4 @@ bool is_boss_of_boat(struct ai_type *ait, struct unit *punit);
 void dai_manage_ferryboat(struct ai_type *ait, struct player *pplayer,
                           struct unit *punit);
 
-#endif /* FC__AIFERRY_H */
+#endif /* FC__DAIFERRY_H */
diff --git a/ai/default/daimilitary.c b/ai/default/daimilitary.c
index b8aa631a83..2e6b8439b2 100644
--- a/ai/default/daimilitary.c
+++ b/ai/default/daimilitary.c
@@ -53,12 +53,12 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "daiair.h"
 #include "daicity.h"
 #include "daidata.h"
 #include "daidiplomat.h"
 #include "daieffects.h"
+#include "daiferry.h"
 #include "daihunter.h"
 #include "dailog.h"
 #include "daiparadrop.h"
diff --git a/ai/default/daisettler.c b/ai/default/daisettler.c
index 5123d911b2..65a32290d1 100644
--- a/ai/default/daisettler.c
+++ b/ai/default/daisettler.c
@@ -55,9 +55,9 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "daicity.h"
 #include "daidata.h"
+#include "daiferry.h"
 #include "dailog.h"
 #include "daiplayer.h"
 #include "daitools.h"
diff --git a/ai/default/daitools.c b/ai/default/daitools.c
index 70fff2dd36..070528f8a7 100644
--- a/ai/default/daitools.c
+++ b/ai/default/daitools.c
@@ -59,9 +59,9 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "aiguard.h"
 #include "daidata.h"
+#include "daiferry.h"
 #include "dailog.h"
 #include "daimilitary.h"
 #include "daiplayer.h"
diff --git a/ai/default/daiunit.c b/ai/default/daiunit.c
index 6e8392ac6a..9ded8fe425 100644
--- a/ai/default/daiunit.c
+++ b/ai/default/daiunit.c
@@ -66,13 +66,13 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "aiguard.h"
 #include "daiair.h"
 #include "daicity.h"
 #include "daidata.h"
 #include "daidiplomat.h"
 #include "daieffects.h"
+#include "daiferry.h"
 #include "daihunter.h"
 #include "dailog.h"
 #include "daimilitary.h"
diff --git a/ai/tex/texai.c b/ai/tex/texai.c
index 456391319b..3b647b5646 100644
--- a/ai/tex/texai.c
+++ b/ai/tex/texai.c
@@ -20,10 +20,10 @@
 #include "world_object.h"
 
 /* ai/default */
-#include "aiferry.h"
 #include "daicity.h"
 #include "daidiplomacy.h"
 #include "daidomestic.h"
+#include "daiferry.h"
 #include "daihand.h"
 #include "dailog.h"
 #include "daimilitary.h"
diff --git a/meson.build b/meson.build
index f412473e01..43ae784c62 100644
--- a/meson.build
+++ b/meson.build
@@ -1519,7 +1519,6 @@ ais = static_library('fc_ai',
   'ai/tex/texaimsg.c',
   'ai/tex/texaiplayer.c',
   'ai/tex/texaiworld.c',
-  'ai/default/aiferry.c',
   'ai/default/aiguard.c',
   'ai/default/daiair.c',
   'ai/default/daiactions.c',
@@ -1529,6 +1528,7 @@ ais = static_library('fc_ai',
   'ai/default/daidiplomat.c',
   'ai/default/daidomestic.c',
   'ai/default/daieffects.c',
+  'ai/default/daiferry.c',
   'ai/default/daihand.c',
   'ai/default/daihunter.c',
   'ai/default/dailog.c',
-- 
2.47.2